#ifndef REGS_HPP
#define REGS_HPP    "Written by Red Plait"

#include <ida.hpp>
#include <struct.hpp>

struct one_reg {
    int is_s;     /* is register contains offset to struct */
    tid_t tid;    /* tid of structure */
    ulong offset; /* offset from base to current member */
    void reset()
    {
        offset = 0;
        is_s   = 0;
    }
    void set_s(tid_t _tid)
    {
        tid    = _tid;
        offset = 0;
        is_s   = 1;
    }
};

struct my_vm {
    protected:
        one_reg regs[8];
    public:
        int actual;

     my_vm() { reset_regs(); }
     void reset_regs();
     static int get_hreg(int);
     int analize_instr(ea_t addr, ea_t struct_addr, tid_t struct_tid);
     int analize_instr_enum(ea_t addr, ea_t struct_addr, tid_t struct_tid);
    protected:
        void xfer_reg(int,int);
        void reset_reg(int);
        void set_reg(int, tid_t);
};

#endif /* REGS_HPP */
