#ifndef RP_HPP

# define RP_HPP	"Written by Red Plait, 2-IV-2000"

#include <ida.hpp>
#include <bytes.hpp>

#define RP_HEX(c)	btoa((c), 0x10)

/* function declaration */
void rp_set_comment(ea_t, const char *, bool, bool = false);

bool check_for_available_space(ea_t, ulong);

void save_binary_in_file(FILE *, ea_t, ulong);
bool restore_binary_from_file(FILE *, ea_t, ulong);
void save_bytearray_in_file(FILE *, ea_t, ulong, const char *);
void save_wordarray_in_file(FILE *, ea_t, ulong, const char *);
void save_dwordarray_in_file(FILE *, ea_t, ulong, const char *);

void copy_fromIDA(uchar *, ea_t, ulong);
void copy_fromIDA_nozero(uchar *, ea_t, ulong);
void copy_toIDA(uchar *, ea_t, ulong);

#define NO_DO_FLOAT     true
#define NO_DO_DOUBLE	true

#if defined(NO_DO_FLOAT)
inline bool RP_doFloat(ea_t ea)
{
    return doFloat(ea, sizeof(float));
}
#endif

#if defined(NO_DO_DOUBLE)
inline bool RP_doDouble(ea_t ea)
{
    return doDouble(ea, sizeof(double));
}
#endif

void pic_add_dref(ea_t from, ea_t to, dref_t dtype, char dtyp);

#endif /* RP_HPP */
