#include "x86.h"
#include <string.h>

struct RP_opcode opcode_aaa = {
	0,
	0,
	(1 << r_EAX),
	f_AF | f_CF,
	0,
	f_OF | f_PF | f_SF | f_ZF,
	0
};

struct RP_opcode opcode_aad = {
	0,
	0,
	(1 << r_EAX),
	f_PF | f_SF | f_ZF,
	0,
	f_AF | f_CF | f_OF,
	0
};

struct RP_opcode opcode_bsf = {
	0,
	0,
	0,
	f_ZF,
	0,
	f_AF | f_CF | f_OF | f_PF | f_SF,
	1
};

struct RP_opcode opcode_bswap = {
	0,
	FROM_486,
	0,
	0,
	0,
	0,
	1
};

struct RP_opcode opcode_bt = {
	0,
	0,
	0,
	f_CF,
	0,
	f_AF | f_OF | f_PF | f_SF | f_ZF,
	0
};

struct RP_opcode opcode_btc = {
	0,
	0,
	0,
	f_CF,
	0,
	f_AF | f_OF | f_PF | f_SF | f_ZF,
	1
};

struct RP_opcode opcode_call0 = {
	0,
	0,
	(1 << r_ESP),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_cbw = {
	0,
	0,
	(1 << r_EAX),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_cdq = {
	0,
	0,
	(1 << r_EAX) | (1 << r_EDX),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_clts = {
	0,
	0,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_cmovb = {
	0,
	FROM_PPRO,
	0,
	0,
	f_CF,
	0,
	1
};

struct RP_opcode opcode_cmovbe = {
	0,
	FROM_PPRO,
	0,
	0,
	f_CF | f_ZF,
	0,
	1
};

struct RP_opcode opcode_cmovg = {
	0,
	FROM_PPRO,
	0,
	0,
	f_OF | f_SF | f_ZF,
	0,
	1
};

struct RP_opcode opcode_cmovge = {
	0,
	FROM_PPRO,
	0,
	0,
	f_OF | f_SF,
	0,
	1
};

struct RP_opcode opcode_cmovo = {
	0,
	FROM_PPRO,
	0,
	0,
	f_OF,
	0,
	1
};

struct RP_opcode opcode_cmovp = {
	0,
	FROM_PPRO,
	0,
	0,
	f_PF,
	0,
	1
};

struct RP_opcode opcode_cmovs = {
	0,
	FROM_PPRO,
	0,
	0,
	f_SF,
	0,
	1
};

struct RP_opcode opcode_cmovz = {
	0,
	FROM_PPRO,
	0,
	0,
	f_ZF,
	0,
	1
};

struct RP_opcode opcode_cmp = {
	0,
	0,
	0,
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_cmpsb = {
	0,
	0,
	(1 << r_ESI) | (1 << r_EDI),
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	f_DF,
	0,
	0
};

struct RP_opcode opcode_cmpxchg = {
	0,
	FROM_486,
	(1 << r_EAX),
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	0,
	0,
	1
};

struct RP_opcode opcode_cmpxchg8b = {
	0,
	FROM_P,
	(1 << r_EAX) | (1 << r_EDX),
	f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_comiss = {
	SSE,
	0,
	0,
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_cpuid = {
	0,
	FROM_486,
	(1 << r_EAX) | (1 << r_ECX) | (1 << r_EDX) | (1 << r_EBX),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_daa = {
	0,
	0,
	(1 << r_EAX),
	f_AF | f_CF | f_PF | f_SF | f_ZF,
	0,
	f_OF,
	0
};

struct RP_opcode opcode_dec = {
	0,
	0,
	0,
	f_AF | f_OF | f_PF | f_SF | f_ZF,
	0,
	0,
	1
};

struct RP_opcode opcode_fcmovnb = {
	FPU,
	FROM_PPRO,
	0,
	0,
	f_CF,
	0,
	1
};

struct RP_opcode opcode_fcmovnbe = {
	FPU,
	FROM_PPRO,
	0,
	0,
	f_CF | f_ZF,
	0,
	1
};

struct RP_opcode opcode_fcmovne = {
	FPU,
	FROM_PPRO,
	0,
	0,
	f_ZF,
	0,
	1
};

struct RP_opcode opcode_fcmovnu = {
	FPU,
	FROM_PPRO,
	0,
	0,
	f_PF,
	0,
	1
};

struct RP_opcode opcode_fnclex = {
	FPU,
	0,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_fnstenv = {
	FPU,
	0,
	0,
	0,
	0,
	0,
	2
};

struct RP_opcode opcode_fucomip = {
	FPU,
	FROM_PPRO,
	0,
	f_CF | f_PF | f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_idiv = {
	0,
	0,
	(1 << r_EAX) | (1 << r_EDX),
	0,
	0,
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	0
};

struct RP_opcode opcode_imul = {
	0,
	0,
	0,
	f_CF | f_OF,
	0,
	f_AF | f_PF | f_SF | f_ZF,
	1
};

struct RP_opcode opcode_ins = {
	0,
	0,
	(1 << r_EDI),
	0,
	f_DF,
	0,
	0
};

struct RP_opcode opcode_invlpg = {
	0,
	FROM_486,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_ja = {
	0,
	0,
	0,
	0,
	f_CF | f_ZF,
	0,
	0
};

struct RP_opcode opcode_jb = {
	0,
	0,
	0,
	0,
	f_CF,
	0,
	0
};

struct RP_opcode opcode_je = {
	0,
	0,
	0,
	0,
	f_ZF,
	0,
	0
};

struct RP_opcode opcode_jg = {
	0,
	0,
	0,
	0,
	f_OF | f_SF | f_ZF,
	0,
	0
};

struct RP_opcode opcode_jl = {
	0,
	0,
	0,
	0,
	f_OF | f_SF,
	0,
	0
};

struct RP_opcode opcode_jo = {
	0,
	0,
	0,
	0,
	f_OF,
	0,
	0
};

struct RP_opcode opcode_jp = {
	0,
	0,
	0,
	0,
	f_PF,
	0,
	0
};

struct RP_opcode opcode_js = {
	0,
	0,
	0,
	0,
	f_SF,
	0,
	0
};

struct RP_opcode opcode_lar = {
	0,
	0,
	0,
	f_ZF,
	0,
	0,
	1
};

struct RP_opcode opcode_lds = {
	0,
	0,
	(1 << r_DS),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_leave = {
	0,
	0,
	(1 << r_ESP) | (1 << r_EBP),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_les = {
	0,
	0,
	(1 << r_ES),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_lfs = {
	0,
	0,
	(1 << r_FS),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_lgs = {
	0,
	0,
	(1 << r_GS),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_loadall = {
	UNKNOWN_IT,
	0,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_lodsb = {
	0,
	0,
	(1 << r_EAX) | (1 << r_ESI),
	0,
	f_DF,
	0,
	0
};

struct RP_opcode opcode_loopd = {
	0,
	0,
	(1 << r_ECX),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_loopwe = {
	0,
	0,
	(1 << r_ECX),
	0,
	f_ZF,
	0,
	0
};

struct RP_opcode opcode_lsl = {
	0,
	0,
	0,
	f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_lss = {
	0,
	0,
	(1 << r_SS),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_maskmovq = {
	MMX,
	0,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_movs = {
	0,
	0,
	(1 << r_ESI) | (1 << r_EDI),
	0,
	f_DF,
	0,
	0
};

struct RP_opcode opcode_movsx = {
	0,
	0,
	0,
	0,
	0,
	0,
	1
};

struct RP_opcode opcode_mul = {
	0,
	0,
	(1 << r_EAX) | (1 << r_EDX),
	f_CF | f_OF,
	0,
	f_AF | f_PF | f_SF | f_ZF,
	0
};

struct RP_opcode opcode_outs = {
	0,
	0,
	(1 << r_ESI),
	0,
	f_DF,
	0,
	0
};

struct RP_opcode opcode_pfsubr = {
	AMD_3D,
	0,
	0,
	0,
	0,
	0,
	1
};

struct RP_opcode opcode_pmaxub = {
	MMX,
	0,
	0,
	0,
	0,
	0,
	1
};

struct RP_opcode opcode_pop = {
	0,
	0,
	(1 << r_ESP),
	0,
	0,
	0,
	1
};

struct RP_opcode opcode_popa = {
	0,
	0,
	(1 << r_EAX) | (1 << r_ECX) | (1 << r_EDX) | (1 << r_EBX) | (1 << r_ESP) | (1 << r_EBP) | (1 << r_ESI) | (1 << r_EDI),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_popfd = {
	0,
	0,
	(1 << r_ESP),
	f_AF | f_CF | f_DF | f_IF | f_OF | f_PF | f_SF | f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_prefetch = {
	AMD_3D,
	0,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_rcl = {
	0,
	0,
	0,
	f_CF,
	f_CF,
	f_OF,
	1
};

struct RP_opcode opcode_rdpmc = {
	0,
	FROM_PPRO,
	(1 << r_EAX) | (1 << r_EDX),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_rdtsc = {
	0,
	FROM_P,
	(1 << r_EAX) | (1 << r_EDX),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_rol = {
	0,
	0,
	0,
	f_CF,
	0,
	f_OF,
	1
};

struct RP_opcode opcode_rsm = {
	0,
	FROM_486,
	0,
	f_AF | f_CF | f_DF | f_IF | f_OF | f_SF | f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_sahf = {
	0,
	0,
	0,
	f_AF | f_CF | f_PF | f_SF | f_ZF,
	0,
	0,
	0
};

struct RP_opcode opcode_sal = {
	0,
	0,
	0,
	f_CF | f_OF | f_PF | f_SF | f_ZF,
	0,
	f_AF,
	1
};

struct RP_opcode opcode_sbb = {
	0,
	0,
	0,
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	f_CF,
	0,
	1
};

struct RP_opcode opcode_scas = {
	0,
	0,
	(1 << r_EDI),
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	f_DF,
	0,
	0
};

struct RP_opcode opcode_setalc = {
	UNKNOWN_IT,
	0,
	(1 << r_EAX),
	0,
	f_CF,
	0,
	0
};

struct RP_opcode opcode_setnae = {
	0,
	0,
	0,
	0,
	f_CF,
	0,
	1
};

struct RP_opcode opcode_setnbe = {
	0,
	0,
	0,
	0,
	f_CF | f_ZF,
	0,
	1
};

struct RP_opcode opcode_setne = {
	0,
	0,
	0,
	0,
	f_ZF,
	0,
	1
};

struct RP_opcode opcode_setng = {
	0,
	0,
	0,
	0,
	f_OF | f_SF | f_ZF,
	0,
	1
};

struct RP_opcode opcode_setnl = {
	0,
	0,
	0,
	0,
	f_OF | f_SF,
	0,
	1
};

struct RP_opcode opcode_setno = {
	0,
	0,
	0,
	0,
	f_OF,
	0,
	1
};

struct RP_opcode opcode_setnp = {
	0,
	0,
	0,
	0,
	f_PF,
	0,
	1
};

struct RP_opcode opcode_setns = {
	0,
	0,
	0,
	0,
	f_SF,
	0,
	1
};

struct RP_opcode opcode_sfence = {
	SSE,
	0,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_shld = {
	0,
	0,
	0,
	f_CF | f_PF | f_SF | f_ZF,
	0,
	f_AF | f_OF,
	1
};

struct RP_opcode opcode_stc = {
	0,
	0,
	0,
	f_CF,
	0,
	0,
	0
};

struct RP_opcode opcode_std = {
	0,
	0,
	0,
	f_DF,
	0,
	0,
	0
};

struct RP_opcode opcode_sti = {
	0,
	0,
	0,
	f_IF,
	0,
	0,
	0
};

struct RP_opcode opcode_sub = {
	0,
	0,
	0,
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	0,
	0,
	1
};

struct RP_opcode opcode_subps = {
	SSE,
	0,
	0,
	0,
	0,
	0,
	1
};

struct RP_opcode opcode_svdc = {
	UNKNOWN_IT,
	FROM_486,
	0,
	0,
	0,
	0,
	1
};

struct RP_opcode opcode_sysenter = {
	0,
	FROM_PII,
	(1 << r_ESP) | (1 << r_CS) | (1 << r_SS),
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_test = {
	0,
	0,
	0,
	f_CF | f_OF | f_PF | f_SF | f_ZF,
	0,
	f_AF,
	0
};

struct RP_opcode opcode_wrmsr = {
	0,
	FROM_P,
	0,
	0,
	0,
	0,
	0
};

struct RP_opcode opcode_xadd = {
	0,
	FROM_486,
	0,
	f_AF | f_CF | f_OF | f_PF | f_SF | f_ZF,
	0,
	0,
	3
};

struct RP_opcode opcode_xchg = {
	0,
	0,
	0,
	0,
	0,
	0,
	3
};

 struct RP_opcode *RP_data[] = {
/* 1 eq aaa */	&opcode_aaa,
/* 2 eq aad */	&opcode_aad,
/* 3 eq aam */	&opcode_aad,
/* 4 eq aas */	&opcode_aaa,
/* 5 eq adc */	&opcode_sbb,
/* 6 eq add */	&opcode_sub,
/* 7 eq and */	&opcode_sal,
/* 8 eq arpl */	&opcode_lar,
/* 9 eq bound */	&opcode_clts,
/* 10 eq bsf */	&opcode_bsf,
/* 11 eq bsr */	&opcode_bsf,
/* 12 eq bt */	&opcode_bt,
/* 13 eq btc */	&opcode_btc,
/* 14 eq btr */	&opcode_btc,
/* 15 eq bts */	&opcode_btc,
/* 16 eq call0 */	&opcode_call0,
/* 17 eq call1 */	&opcode_call0,
/* 18 eq call2 */	&opcode_call0,
/* 19 eq cbw */	&opcode_cbw,
/* 20 eq cwde */	&opcode_cbw,
/* 21 eq clc */	&opcode_stc,
/* 22 eq cld */	&opcode_std,
/* 23 eq cli */	&opcode_sti,
/* 24 eq clts */	&opcode_clts,
/* 25 eq cmc */	&opcode_stc,
/* 26 eq cmp */	&opcode_cmp,
/* 27 eq cmpsb */	&opcode_cmpsb,
/* 28 eq cwd */	&opcode_cdq,
/* 29 eq cdq */	&opcode_cdq,
/* 30 eq daa */	&opcode_daa,
/* 31 eq das */	&opcode_daa,
/* 32 eq dec */	&opcode_dec,
/* 33 eq div */	&opcode_idiv,
/* 34 eq enterw */	&opcode_leave,
/* 35 eq enter */	&opcode_leave,
/* 36 eq enterd */	&opcode_leave,
/* 37 eq hlt */	&opcode_clts,
/* 38 eq idiv */	&opcode_idiv,
/* 39 eq imul */	&opcode_imul,
/* 40 eq in */	&opcode_cbw,
/* 41 eq inc */	&opcode_dec,
/* 42 eq ins */	&opcode_ins,
/* 43 eq int */	&opcode_call0,
/* 44 eq into */	&opcode_call0,
/* 45 eq int0 */	&opcode_call0,
/* 46 eq iretw */	&opcode_call0,
/* 47 eq iret */	&opcode_call0,
/* 48 eq iretd */	&opcode_call0,
/* 49 eq ja */	&opcode_ja,
/* 50 eq jae */	&opcode_jb,
/* 51 eq jb */	&opcode_jb,
/* 52 eq jbe */	&opcode_ja,
/* 53 eq jc */	&opcode_jb,
/* 54 eq jcxz */	&opcode_clts,
/* 55 eq jecxz */	&opcode_clts,
/* 56 eq je */	&opcode_je,
/* 57 eq jg */	&opcode_jg,
/* 58 eq jge */	&opcode_jl,
/* 59 eq jl */	&opcode_jl,
/* 60 eq jle */	&opcode_jg,
/* 61 eq jna */	&opcode_ja,
/* 62 eq jnae */	&opcode_jb,
/* 63 eq jnb */	&opcode_jb,
/* 64 eq jnbe */	&opcode_ja,
/* 65 eq jnc */	&opcode_jb,
/* 66 eq jne */	&opcode_je,
/* 67 eq jng */	&opcode_jg,
/* 68 eq jnge */	&opcode_jl,
/* 69 eq jnl */	&opcode_jl,
/* 70 eq jnle */	&opcode_jg,
/* 71 eq jno */	&opcode_jo,
/* 72 eq jnp */	&opcode_jp,
/* 73 eq jns */	&opcode_js,
/* 74 eq jnz */	&opcode_je,
/* 75 eq jo */	&opcode_jo,
/* 76 eq jp */	&opcode_jp,
/* 77 eq jpe */	&opcode_jp,
/* 78 eq jpo */	&opcode_jo,
/* 79 eq js */	&opcode_js,
/* 80 eq jz */	&opcode_je,
/* 81 eq jmp0 */	&opcode_clts,
/* 82 eq jmp1 */	&opcode_clts,
/* 83 eq jmp2 */	&opcode_clts,
/* 84 eq jmp3 */	&opcode_clts,
/* 85 eq lahf */	&opcode_cbw,
/* 86 eq lar */	&opcode_lar,
/* 87 eq lea */	&opcode_movsx,
/* 88 eq leavew */	&opcode_leave,
/* 89 eq leave */	&opcode_leave,
/* 90 eq leaved */	&opcode_leave,
/* 91 eq lgdt */	&opcode_clts,
/* 92 eq lidt */	&opcode_clts,
/* 93 eq lgs */	&opcode_lgs,
/* 94 eq lss */	&opcode_lss,
/* 95 eq lds */	&opcode_lds,
/* 96 eq les */	&opcode_les,
/* 97 eq lfs */	&opcode_lfs,
/* 98 eq lldt */	&opcode_clts,
/* 99 eq lmsw */	&opcode_clts,
/* 100 */	NULL,
/* 101 eq lodsb */	&opcode_lodsb,
/* 102 eq loopw */	&opcode_loopd,
/* 103 eq loop */	&opcode_loopd,
/* 104 eq loopd */	&opcode_loopd,
/* 105 eq loopwe */	&opcode_loopwe,
/* 106 eq loope */	&opcode_loopwe,
/* 107 eq loopde */	&opcode_loopwe,
/* 108 eq loopwne */	&opcode_loopwe,
/* 109 eq loopne */	&opcode_loopwe,
/* 110 eq loopdne */	&opcode_loopwe,
/* 111 eq lsl */	&opcode_lsl,
/* 112 eq ltr */	&opcode_clts,
/* 113 eq mov */	&opcode_movsx,
/* 114 eq mov0 */	&opcode_movsx,
/* 115 eq movs */	&opcode_movs,
/* 116 eq movsx */	&opcode_movsx,
/* 117 eq movzx */	&opcode_movsx,
/* 118 eq mul */	&opcode_mul,
/* 119 eq neg */	&opcode_sub,
/* 120 eq nop */	&opcode_clts,
/* 121 eq not */	&opcode_movsx,
/* 122 eq or */	&opcode_sal,
/* 123 eq out */	&opcode_clts,
/* 124 eq outs */	&opcode_outs,
/* 125 eq pop */	&opcode_pop,
/* 126 eq popaw */	&opcode_popa,
/* 127 eq popa */	&opcode_popa,
/* 128 eq popad */	&opcode_popa,
/* 129 eq popfw */	&opcode_popfd,
/* 130 eq popf */	&opcode_popfd,
/* 131 eq popfd */	&opcode_popfd,
/* 132 eq push */	&opcode_call0,
/* 133 eq pushaw */	&opcode_call0,
/* 134 eq pusha */	&opcode_call0,
/* 135 eq pushad */	&opcode_call0,
/* 136 eq pushfw */	&opcode_call0,
/* 137 eq pushf */	&opcode_call0,
/* 138 eq pushfd */	&opcode_call0,
/* 139 eq rcl */	&opcode_rcl,
/* 140 eq rcr */	&opcode_rcl,
/* 141 eq rol */	&opcode_rol,
/* 142 eq ror */	&opcode_rol,
/* 143 */	NULL,
/* 144 */	NULL,
/* 145 */	NULL,
/* 146 eq ret */	&opcode_call0,
/* 147 eq retf */	&opcode_call0,
/* 148 eq sahf */	&opcode_sahf,
/* 149 eq sal */	&opcode_sal,
/* 150 eq sar */	&opcode_sal,
/* 151 eq shl */	&opcode_sal,
/* 152 eq shr */	&opcode_sal,
/* 153 eq sbb */	&opcode_sbb,
/* 154 eq scas */	&opcode_scas,
/* 155 eq seta */	&opcode_setnbe,
/* 156 eq setae */	&opcode_setnae,
/* 157 eq setb */	&opcode_setnae,
/* 158 eq setbe */	&opcode_setnbe,
/* 159 eq setc */	&opcode_setnae,
/* 160 eq sete */	&opcode_setne,
/* 161 eq setg */	&opcode_setng,
/* 162 eq setge */	&opcode_setnl,
/* 163 eq setl */	&opcode_setnl,
/* 164 eq setle */	&opcode_setng,
/* 165 eq setna */	&opcode_setnbe,
/* 166 eq setnae */	&opcode_setnae,
/* 167 eq setnb */	&opcode_setnae,
/* 168 eq setnbe */	&opcode_setnbe,
/* 169 eq setnc */	&opcode_setnae,
/* 170 eq setne */	&opcode_setne,
/* 171 eq setng */	&opcode_setng,
/* 172 eq setnge */	&opcode_setnl,
/* 173 eq setnl */	&opcode_setnl,
/* 174 eq setnle */	&opcode_setng,
/* 175 eq setno */	&opcode_setno,
/* 176 eq setnp */	&opcode_setnp,
/* 177 eq setns */	&opcode_setns,
/* 178 eq setnz */	&opcode_setne,
/* 179 eq seto */	&opcode_setno,
/* 180 eq setp */	&opcode_setnp,
/* 181 eq setpe */	&opcode_setnp,
/* 182 eq setpo */	&opcode_setnp,
/* 183 eq sets */	&opcode_setns,
/* 184 eq setz */	&opcode_setne,
/* 185 eq sgdt */	&opcode_movsx,
/* 186 eq sidt */	&opcode_movsx,
/* 187 eq shld */	&opcode_shld,
/* 188 eq shrd */	&opcode_shld,
/* 189 eq sldt */	&opcode_movsx,
/* 190 eq smsw */	&opcode_movsx,
/* 191 eq stc */	&opcode_stc,
/* 192 eq std */	&opcode_std,
/* 193 eq sti */	&opcode_sti,
/* 194 eq stos */	&opcode_ins,
/* 195 eq str */	&opcode_movsx,
/* 196 eq sub */	&opcode_sub,
/* 197 eq test */	&opcode_test,
/* 198 eq verr */	&opcode_lsl,
/* 199 eq verw */	&opcode_lsl,
/* 200 eq wait */	&opcode_clts,
/* 201 eq xchg */	&opcode_xchg,
/* 202 eq xlat */	&opcode_cbw,
/* 203 eq xor */	&opcode_sal,
/* 204 eq cmpxchg */	&opcode_cmpxchg,
/* 205 eq bswap */	&opcode_bswap,
/* 206 eq xadd */	&opcode_xadd,
/* 207 eq invd */	&opcode_invlpg,
/* 208 eq wbinvd */	&opcode_invlpg,
/* 209 eq invlpg */	&opcode_invlpg,
/* 210 eq rdmsr */	&opcode_rdtsc,
/* 211 eq wrmsr */	&opcode_wrmsr,
/* 212 eq cpuid */	&opcode_cpuid,
/* 213 eq cmpxchg8b */	&opcode_cmpxchg8b,
/* 214 eq rdtsc */	&opcode_rdtsc,
/* 215 eq rsm */	&opcode_rsm,
/* 216 eq cmova */	&opcode_cmovbe,
/* 217 eq cmovb */	&opcode_cmovb,
/* 218 eq cmovbe */	&opcode_cmovbe,
/* 219 eq cmovg */	&opcode_cmovg,
/* 220 eq cmovge */	&opcode_cmovge,
/* 221 eq cmovl */	&opcode_cmovge,
/* 222 eq cmovle */	&opcode_cmovg,
/* 223 eq cmovnb */	&opcode_cmovb,
/* 224 eq cmovno */	&opcode_cmovo,
/* 225 eq cmovnp */	&opcode_cmovp,
/* 226 eq cmovns */	&opcode_cmovs,
/* 227 eq cmovnz */	&opcode_cmovz,
/* 228 eq cmovo */	&opcode_cmovo,
/* 229 eq cmovp */	&opcode_cmovp,
/* 230 eq cmovs */	&opcode_cmovs,
/* 231 eq cmovz */	&opcode_cmovz,
/* 232 eq fcmovb */	&opcode_fcmovnb,
/* 233 eq fcmove */	&opcode_fcmovne,
/* 234 eq fcmovbe */	&opcode_fcmovnbe,
/* 235 eq fcmovu */	&opcode_fcmovnu,
/* 236 eq fcmovnb */	&opcode_fcmovnb,
/* 237 eq fcmovne */	&opcode_fcmovne,
/* 238 eq fcmovnbe */	&opcode_fcmovnbe,
/* 239 eq fcmovnu */	&opcode_fcmovnu,
/* 240 eq fcomi */	&opcode_fucomip,
/* 241 eq fucomi */	&opcode_fucomip,
/* 242 eq fcomip */	&opcode_fucomip,
/* 243 eq fucomip */	&opcode_fucomip,
/* 244 eq rdpmc */	&opcode_rdpmc,
/* 245 eq fld */	&opcode_fnclex,
/* 246 eq fst */	&opcode_fnstenv,
/* 247 eq fstp */	&opcode_fnstenv,
/* 248 eq fxch */	&opcode_fnclex,
/* 249 eq fild */	&opcode_fnclex,
/* 250 eq fist */	&opcode_fnstenv,
/* 251 eq fistp */	&opcode_fnstenv,
/* 252 eq fbld */	&opcode_fnclex,
/* 253 eq fbstp */	&opcode_fnstenv,
/* 254 eq fadd */	&opcode_fnclex,
/* 255 eq faddp */	&opcode_fnclex,
/* 256 eq fiadd */	&opcode_fnclex,
/* 257 eq fsub */	&opcode_fnclex,
/* 258 eq fsubp */	&opcode_fnclex,
/* 259 eq fisub */	&opcode_fnclex,
/* 260 eq fsubr */	&opcode_fnclex,
/* 261 eq fsubrp */	&opcode_fnclex,
/* 262 eq fisubr */	&opcode_fnclex,
/* 263 eq fmul */	&opcode_fnclex,
/* 264 eq fmulp */	&opcode_fnclex,
/* 265 eq fimul */	&opcode_fnclex,
/* 266 eq fdiv */	&opcode_fnclex,
/* 267 eq fdivp */	&opcode_fnclex,
/* 268 eq fidiv */	&opcode_fnclex,
/* 269 eq fdivr */	&opcode_fnclex,
/* 270 eq fdivrp */	&opcode_fnclex,
/* 271 eq fidivr */	&opcode_fnclex,
/* 272 eq fsqrt */	&opcode_fnclex,
/* 273 eq fscale */	&opcode_fnclex,
/* 274 eq fprem */	&opcode_fnclex,
/* 275 eq frndint */	&opcode_fnclex,
/* 276 eq fxtract */	&opcode_fnclex,
/* 277 eq fabs */	&opcode_fnclex,
/* 278 eq fchs */	&opcode_fnclex,
/* 279 eq fcom */	&opcode_fnclex,
/* 280 eq fcomp */	&opcode_fnclex,
/* 281 eq fcompp */	&opcode_fnclex,
/* 282 eq ficom */	&opcode_fnclex,
/* 283 eq ficomp */	&opcode_fnclex,
/* 284 eq ftst */	&opcode_fnclex,
/* 285 eq fxam */	&opcode_fnclex,
/* 286 eq fptan */	&opcode_fnclex,
/* 287 eq fpatan */	&opcode_fnclex,
/* 288 eq f2xm1 */	&opcode_fnclex,
/* 289 eq fyl2x */	&opcode_fnclex,
/* 290 eq fyl2xp1 */	&opcode_fnclex,
/* 291 eq fldz */	&opcode_fnclex,
/* 292 eq fld1 */	&opcode_fnclex,
/* 293 eq fldpi */	&opcode_fnclex,
/* 294 eq fldl2t */	&opcode_fnclex,
/* 295 eq fldl2e */	&opcode_fnclex,
/* 296 eq fldlg2 */	&opcode_fnclex,
/* 297 eq fldln2 */	&opcode_fnclex,
/* 298 eq finit */	&opcode_fnclex,
/* 299 eq fninit */	&opcode_fnclex,
/* 300 eq fsetpm */	&opcode_clts,
/* 301 eq fldcw */	&opcode_fnclex,
/* 302 eq fstcw */	&opcode_fnstenv,
/* 303 eq fnstcw */	&opcode_fnstenv,
/* 304 eq fstsw */	&opcode_fnstenv,
/* 305 eq fnstsw */	&opcode_fnstenv,
/* 306 eq fclex */	&opcode_fnclex,
/* 307 eq fnclex */	&opcode_fnclex,
/* 308 eq fstenv */	&opcode_fnstenv,
/* 309 eq fnstenv */	&opcode_fnstenv,
/* 310 eq fldenv */	&opcode_fnclex,
/* 311 eq fsave */	&opcode_fnstenv,
/* 312 eq fnsave */	&opcode_fnstenv,
/* 313 eq frstor */	&opcode_fnclex,
/* 314 eq fincstp */	&opcode_fnclex,
/* 315 eq fdecstp */	&opcode_fnclex,
/* 316 eq ffree */	&opcode_fnclex,
/* 317 eq fnop */	&opcode_fnclex,
/* 318 eq feni */	&opcode_fnclex,
/* 319 eq fneni */	&opcode_fnclex,
/* 320 eq fdisi */	&opcode_fnclex,
/* 321 eq fndisi */	&opcode_fnclex,
/* 322 eq fprem1 */	&opcode_fnclex,
/* 323 eq fsincos */	&opcode_fnclex,
/* 324 eq fsin */	&opcode_fnclex,
/* 325 eq fcos */	&opcode_fnclex,
/* 326 eq fucom */	&opcode_fnclex,
/* 327 eq fucomp */	&opcode_fnclex,
/* 328 eq fucompp */	&opcode_fnclex,
/* 329 eq setalc */	&opcode_setalc,
/* 330 eq svdc */	&opcode_svdc,
/* 331 eq rsdc */	&opcode_svdc,
/* 332 eq svldt */	&opcode_svdc,
/* 333 eq rsldt */	&opcode_svdc,
/* 334 eq svts */	&opcode_svdc,
/* 335 eq rsts */	&opcode_svdc,
/* 336 eq icebp */	&opcode_loadall,
/* 337 eq loadall */	&opcode_loadall,
/* 338 eq emms */	&opcode_maskmovq,
/* 339 eq movd */	&opcode_pmaxub,
/* 340 eq movq */	&opcode_pmaxub,
/* 341 eq packsswb */	&opcode_pmaxub,
/* 342 eq packssdw */	&opcode_pmaxub,
/* 343 eq packuswb */	&opcode_pmaxub,
/* 344 eq paddb */	&opcode_pmaxub,
/* 345 eq paddw */	&opcode_pmaxub,
/* 346 eq paddd */	&opcode_pmaxub,
/* 347 eq paddsb */	&opcode_pmaxub,
/* 348 eq paddsw */	&opcode_pmaxub,
/* 349 eq paddusb */	&opcode_pmaxub,
/* 350 eq paddusw */	&opcode_pmaxub,
/* 351 eq pand */	&opcode_pmaxub,
/* 352 eq pandn */	&opcode_pmaxub,
/* 353 eq pcmpeqb */	&opcode_pmaxub,
/* 354 eq pcmpeqw */	&opcode_pmaxub,
/* 355 eq pcmpeqd */	&opcode_pmaxub,
/* 356 eq pcmpgtb */	&opcode_pmaxub,
/* 357 eq pcmpgtw */	&opcode_pmaxub,
/* 358 eq pcmpgtd */	&opcode_pmaxub,
/* 359 eq pmaddwd */	&opcode_pmaxub,
/* 360 eq pmulhw */	&opcode_pmaxub,
/* 361 eq pmullw */	&opcode_pmaxub,
/* 362 eq por */	&opcode_pmaxub,
/* 363 eq psllw */	&opcode_pmaxub,
/* 364 eq pslld */	&opcode_pmaxub,
/* 365 eq psllq */	&opcode_pmaxub,
/* 366 eq psraw */	&opcode_pmaxub,
/* 367 eq psrad */	&opcode_pmaxub,
/* 368 eq psrlw */	&opcode_pmaxub,
/* 369 eq psrld */	&opcode_pmaxub,
/* 370 eq psrlq */	&opcode_pmaxub,
/* 371 eq psubb */	&opcode_pmaxub,
/* 372 eq psubw */	&opcode_pmaxub,
/* 373 eq psubd */	&opcode_pmaxub,
/* 374 eq psubsb */	&opcode_pmaxub,
/* 375 eq psubsw */	&opcode_pmaxub,
/* 376 eq psubusb */	&opcode_pmaxub,
/* 377 eq psubusw */	&opcode_pmaxub,
/* 378 eq punpckhbw */	&opcode_pmaxub,
/* 379 eq punpckhwd */	&opcode_pmaxub,
/* 380 eq punpckhdq */	&opcode_pmaxub,
/* 381 eq punpcklbw */	&opcode_pmaxub,
/* 382 eq punpcklwd */	&opcode_pmaxub,
/* 383 eq punpckldq */	&opcode_pmaxub,
/* 384 eq pxor */	&opcode_pmaxub,
/* 385 eq fxsave */	&opcode_subps,
/* 386 eq fxrstor */	&opcode_sfence,
/* 387 eq sysenter */	&opcode_sysenter,
/* 388 eq sysexit */	&opcode_sysenter,
/* 389 eq pavgusb */	&opcode_pfsubr,
/* 390 eq pfadd */	&opcode_pfsubr,
/* 391 eq pfsub */	&opcode_pfsubr,
/* 392 eq pfsubr */	&opcode_pfsubr,
/* 393 eq pfacc */	&opcode_pfsubr,
/* 394 eq pfcmpge */	&opcode_pfsubr,
/* 395 eq pfcmpgt */	&opcode_pfsubr,
/* 396 eq pfcmpeq */	&opcode_pfsubr,
/* 397 eq pfmin */	&opcode_pfsubr,
/* 398 eq pfmax */	&opcode_pfsubr,
/* 399 eq pi2fd */	&opcode_pfsubr,
/* 400 eq pf2id */	&opcode_pfsubr,
/* 401 eq pfrcp */	&opcode_pfsubr,
/* 402 eq pfrsqrt */	&opcode_pfsubr,
/* 403 eq pfmul */	&opcode_pfsubr,
/* 404 eq pfrcpit1 */	&opcode_pfsubr,
/* 405 eq pfrsqit1 */	&opcode_pfsubr,
/* 406 eq pfrcpit2 */	&opcode_pfsubr,
/* 407 eq pmulhrw */	&opcode_pfsubr,
/* 408 eq femms */	&opcode_prefetch,
/* 409 eq prefetch */	&opcode_prefetch,
/* 410 eq prefetchw */	&opcode_prefetch,
/* 411 eq addps */	&opcode_subps,
/* 412 eq addss */	&opcode_subps,
/* 413 eq andnps */	&opcode_subps,
/* 414 eq andps */	&opcode_subps,
/* 415 eq cmpps */	&opcode_subps,
/* 416 eq cmpss */	&opcode_subps,
/* 417 eq comiss */	&opcode_comiss,
/* 418 eq cvtpi2ps */	&opcode_subps,
/* 419 eq cvtps2pi */	&opcode_subps,
/* 420 eq cvtsi2ss */	&opcode_subps,
/* 421 eq cvtss2si */	&opcode_subps,
/* 422 eq cvttps2pi */	&opcode_subps,
/* 423 eq cvttss2si */	&opcode_subps,
/* 424 eq divps */	&opcode_subps,
/* 425 eq divss */	&opcode_subps,
/* 426 eq ldmxcsr */	&opcode_sfence,
/* 427 eq maxps */	&opcode_subps,
/* 428 eq maxss */	&opcode_subps,
/* 429 eq minps */	&opcode_subps,
/* 430 eq minss */	&opcode_subps,
/* 431 eq movaps */	&opcode_subps,
/* 432 eq movhlps */	&opcode_subps,
/* 433 eq movhps */	&opcode_subps,
/* 434 eq movlhps */	&opcode_subps,
/* 435 eq movlps */	&opcode_subps,
/* 436 eq movmskps */	&opcode_subps,
/* 437 eq movss */	&opcode_subps,
/* 438 eq movups */	&opcode_subps,
/* 439 eq mulps */	&opcode_subps,
/* 440 eq mulss */	&opcode_subps,
/* 441 eq orps */	&opcode_subps,
/* 442 eq rcpps */	&opcode_subps,
/* 443 eq rcpss */	&opcode_subps,
/* 444 eq rsqrtps */	&opcode_subps,
/* 445 eq rsqrtss */	&opcode_subps,
/* 446 eq shufps */	&opcode_subps,
/* 447 eq sqrtps */	&opcode_subps,
/* 448 eq sqrtss */	&opcode_subps,
/* 449 eq stmxcsr */	&opcode_subps,
/* 450 eq subps */	&opcode_subps,
/* 451 eq subss */	&opcode_subps,
/* 452 eq ucomiss */	&opcode_comiss,
/* 453 eq unpckhps */	&opcode_subps,
/* 454 eq unpcklps */	&opcode_subps,
/* 455 eq xorps */	&opcode_subps,
/* 456 eq pavgb */	&opcode_pmaxub,
/* 457 eq pavgw */	&opcode_pmaxub,
/* 458 eq pextrw */	&opcode_pmaxub,
/* 459 eq pinsrw */	&opcode_pmaxub,
/* 460 eq pmaxsw */	&opcode_pmaxub,
/* 461 eq pmaxub */	&opcode_pmaxub,
/* 462 eq pminsw */	&opcode_pmaxub,
/* 463 eq pminub */	&opcode_pmaxub,
/* 464 eq pmovmskb */	&opcode_pmaxub,
/* 465 eq pmulhuw */	&opcode_pmaxub,
/* 466 eq psadbw */	&opcode_pmaxub,
/* 467 eq pshufw */	&opcode_pmaxub,
/* 468 eq maskmovq */	&opcode_maskmovq,
/* 469 eq movntps */	&opcode_subps,
/* 470 eq movntq */	&opcode_subps,
/* 471 eq prefetcht0 */	&opcode_sfence,
/* 472 eq prefetcht1 */	&opcode_sfence,
/* 473 eq prefetcht2 */	&opcode_sfence,
/* 474 eq prefetchnta */	&opcode_sfence,
/* 475 eq sfence */	&opcode_sfence,
/* 476 eq cmpeqps */	&opcode_subps,
/* 477 eq cmpltps */	&opcode_subps,
/* 478 eq cmpleps */	&opcode_subps,
/* 479 eq cmpunordps */	&opcode_subps,
/* 480 eq cmpneqps */	&opcode_subps,
/* 481 eq cmpnltps */	&opcode_subps,
/* 482 eq cmpnleps */	&opcode_subps,
/* 483 eq cmpordps */	&opcode_subps,
/* 484 eq cmpeqss */	&opcode_subps,
/* 485 eq cmpltss */	&opcode_subps,
/* 486 eq cmpless */	&opcode_subps,
/* 487 eq cmpunordss */	&opcode_subps,
/* 488 eq cmpneqss */	&opcode_subps,
/* 489 eq cmpnltss */	&opcode_subps,
/* 490 eq cmpnless */	&opcode_subps,
/* 491 eq cmpordss */	&opcode_subps,
 };
