#ifndef __FLOW_H
#define __FLOW_H

// This file contains the essential parts to create pointer control flow graphs


// IDA does a value->bool conversion, so disable the performance warning
#pragma warning( disable : 4800 )
// IDA references an internal type as both class and struct..
#pragma warning( disable : 4099 )

#include "legacy.hpp"
#include "graphnode.hpp"
#include "insx86.hpp"
#include "ptrgraph.hpp"
#include "objrec.hpp"

PtrGraph *CreateFlowPtrGraph(ea_t begin, reg_t reg, unsigned int stackofs, rec_t recmode);
void  AddFlow(PtrGraph *PtrGraph, GraphNode *from, ea_t begin, reg_t reg, unsigned int stackofs, rec_t recmode);

#endif
