#ifndef __ins_x86
#define __ins_x86

enum    reg_t{
        r_eax,  //0
        r_ecx,  //1
        r_edx,  //2
        r_ebx,  //3
        r_esp,  //4
        r_ebp,  //5
        r_esi,  //6
        r_edi,   //7
        r_none};

enum    ins_t{
        x86_UNDEF,
        x86_aaa,
        x86_aad,
        x86_aam,
        x86_aas,
        x86_adc,
        x86_add,
        x86_and,
        x86_arpl,
        x86_bound,
        x86_bsf,
        x86_bsr,
        x86_bt,
        x86_btc,
        x86_btr,
        x86_bts,
        x86_callA,
        x86_callB,
        x86_callC,
        x86_cbw,
        x86_cwde,
        x86_clc,
        x86_cld,
        x86_cli,
        x86_clts,
        x86_cmc,
        x86_cmp,
        x86_cmps,
        x86_cwd,
        x86_cdq,
        x86_daa,
        x86_das,
        x86_dec,
        x86_div,
        x86_enterw,
        x86_enter,
        x86_enterd,
        x86_hlt,
        x86_idiv,
        x86_imul,
        x86_in,
        x86_inc,
        x86_ins,
        x86_intA,
        x86_into,
        x86_intB,
        x86_iretw,
        x86_iret,
        x86_iretd,
        x86_ja,
        x86_jae,
        x86_jb,
        x86_jbe,
        x86_jc,
        x86_jcxz,
        x86_jecxz,
        x86_je,
        x86_jg,
        x86_jge,
        x86_jl,
        x86_jle,
        x86_jna,
        x86_jnae,
        x86_jnb,
        x86_jnbe,
        x86_jnc,
        x86_jne,
        x86_jng,
        x86_jnge,
        x86_jnl,
        x86_jnle,
        x86_jno,
        x86_jnp,
        x86_jns,
        x86_jnz,
        x86_jo,
        x86_jp,
        x86_jpe,
        x86_jpo,
        x86_js,
        x86_jz,
        x86_jmpA,
        x86_jmpB,
        x86_jmpC,
        x86_jmp_short,
        x86_lahf,
        x86_lar,
        x86_lea,
        x86_leavew,
        x86_leave,
        x86_leaved,
        x86_lgdt,
        x86_lidt,
        x86_lgs,
        x86_lss,
        x86_lds,
        x86_les,
        x86_lfs,
        x86_lldt,
        x86_lmsw,
        x86_UNDEF2,
        x86_lods,
        x86_loopw,
        x86_loop,
        x86_loopd,
        x86_loopwe,
        x86_loope,
        x86_loopde,
        x86_loopwne,
        x86_loopne,
        x86_loopdne,
        x86_lsl,
        x86_ltr,
        x86_movA,
        x86_movB,
        x86_movs,
        x86_movsx,
        x86_movzx,
        x86_mul,
        x86_neg,
        x86_nop,
        x86_not,
        x86_or,
        x86_out,
        x86_outs,
        x86_pop,
        x86_popaw,
        x86_popa,
        x86_popad,
        x86_popfw,
        x86_popf,
        x86_popfd,
        x86_push,
        x86_pushaw,
        x86_pusha,
        x86_pushad,
        x86_pushfw,
        x86_pushf,
        x86_pushfd,
        x86_rcl,
        x86_rcr,
        x86_rol,
        x86_ror,
        x86_UNDEF3,
        x86_UNDEF4,
        x86_UNDEF5,
        x86_retn,
        x86_retf,
        x86_sahf,
        x86_sal,
        x86_sar,
        x86_shl,
        x86_shr,
        x86_sbb,
        x86_scas,
        x86_seta,
        x86_setae,
        x86_setb,
        x86_setbe,
        x86_setc,
        x86_sete,
        x86_setg,
        x86_setge,
        x86_setl,
        x86_setle,
        x86_setna,
        x86_setnae,
        x86_setnb,
        x86_setnbe,
        x86_setnc,
        x86_setne,
        x86_setng,
        x86_setnge,
        x86_setnl,
        x86_setnle,
        x86_setno,
        x86_setnp,
        x86_setns,
        x86_setnz,
        x86_seto,
        x86_setp,
        x86_setpe,
        x86_setpo,
        x86_sets,
        x86_setz,
        x86_sgdt,
        x86_sidt,
        x86_shld,
        x86_shrd,
        x86_sldt,
        x86_smsw,
        x86_stc,
        x86_std,
        x86_sti,
        x86_stos,
        x86_str,
        x86_sub,
        x86_test,
        x86_verr,
        x86_verw,
        x86_wait,
        x86_xchg,
        x86_xlat,
        x86_xor,
        x86_cmpxchg,
        x86_bswap,
        x86_xadd,
        x86_invd,
        x86_wbinvd,
        x86_invlpg,
        x86_rdmsr,
        x86_wrmsr,
        x86_cpuid,
        x86_cmpxchg8b,
        x86_rdtsc,
        x86_rsm,
        x86_cmova,
        x86_cmovb,
        x86_cmovbe,
        x86_cmovg,
        x86_cmovge,
        x86_cmovl,
        x86_cmovle,
        x86_cmovnb,
        x86_cmovno,
        x86_cmovnp,
        x86_cmovns,
        x86_cmovnz,
        x86_cmovo,
        x86_cmovp,
        x86_cmovs,
        x86_cmovz,
        x86_fcmovb,
        x86_fcmove,
        x86_fcmovbe,
        x86_fcmovu,
        x86_fcmovnb,
        x86_fcmovne,
        x86_fcmovnbe,
        x86_fcmovnu,
        x86_fcomi,
        x86_fucomi,
        x86_fcomip,
        x86_fucomip,
        x86_rdpmc,
        x86_fld,
        x86_fst,
        x86_fstp,
        x86_fxch,
        x86_fild,
        x86_fist,
        x86_fistp,
        x86_fbld,
        x86_fbstp,
        x86_fadd,
        x86_faddp,
        x86_fiadd,
        x86_fsub,
        x86_fsubp,
        x86_fisub,
        x86_fsubr,
        x86_fsubrp,
        x86_fisubr,
        x86_fmul,
        x86_fmulp,
        x86_fimul,
        x86_fdiv,
        x86_fdivp,
        x86_fidiv,
        x86_fdivr,
        x86_fdivrp,
        x86_fidivr,
        x86_fsqrt,
        x86_fscale,
        x86_fprem,
        x86_frndint,
        x86_fxtract,
        x86_fabs,
        x86_fchs,
        x86_fcom,
        x86_fcomp,
        x86_fcompp,
        x86_ficom,
        x86_ficomp,
        x86_ftst,
        x86_fxam,
        x86_fptan,
        x86_fpatan,
        x86_f2xm1,
        x86_fyl2x,
        x86_fyl2xp1,
        x86_fldz,
        x86_fld1,
        x86_fldpi,
        x86_fldl2t,
        x86_fldl2e,
        x86_fldlg2,
        x86_fldln2,
        x86_finit,
        x86_fninit,
        x86_fsetpm,
        x86_fldcw,
        x86_fstcw,
        x86_fnstcw,
        x86_fstsw,
        x86_fnstsw,
        x86_fclex,
        x86_fnclex,
        x86_fstenv,
        x86_fnstenv,
        x86_fldenv,
        x86_fsave,
        x86_fnsave,
        x86_frstor,
        x86_fincstp,
        x86_fdecstp,
        x86_ffree,
        x86_fnop,
        x86_feni,
        x86_fneni,
        x86_fdisi,
        x86_fndisi,
        x86_fprem1,
        x86_fsincos,
        x86_fsin,
        x86_fcos,
        x86_fucom,
        x86_fucomp,
        x86_fucompp,
        x86_setalc,
        x86_svdc,
        x86_rsdc,
        x86_svldt,
        x86_rsldt,
        x86_svts,
        x86_rsts,
        x86_icebp,
        x86_loadall,
        x86_emms,
        x86_movd,
        x86_movq,
        x86_packsswb,
        x86_packssdw,
        x86_packuswb,
        x86_paddb,
        x86_paddw,
        x86_paddd,
        x86_paddsb,
        x86_paddsw,
        x86_paddusb,
        x86_paddusw,
        x86_pand,
        x86_pandn,
        x86_pcmpeqb,
        x86_pcmpeqw,
        x86_pcmpeqd,
        x86_pcmpgtb,
        x86_pcmpgtw,
        x86_pcmpgtd,
        x86_pmaddwd,
        x86_pmulhw,
        x86_pmullw,
        x86_por,
        x86_psllw,
        x86_pslld,
        x86_psllq,
        x86_psraw,
        x86_psrad,
        x86_psrlw,
        x86_psrld,
        x86_psrlq,
        x86_psubb,
        x86_psubw,
        x86_psubd,
        x86_psubsb,
        x86_psubsw,
        x86_psubusb,
        x86_psubusw,
        x86_punpckhbw,
        x86_punpckhwd,
        x86_punpckhdq,
        x86_punpcklbw,
        x86_punpcklwd,
        x86_punpckldq,
        x86_pxor,
        x86_fxsave,
        x86_fxrstor,
        x86_sysenter,
        x86_sysexit,
        x86_pavgusb,
        x86_pfadd,
        x86_pfsub,
        x86_pfsubr,
        x86_pfacc,
        x86_pfcmpge,
        x86_pfcmpgt,
        x86_pfcmpeq,
        x86_pfmin,
        x86_pfmax,
        x86_pi2fd,
        x86_pf2id,
        x86_pfrcp,
        x86_pfrsqrt,
        x86_pfmul,
        x86_pfrcpit1,
        x86_pfrsqit1,
        x86_pfrcpit2,
        x86_pmulhrw,
        x86_femms,
        x86_prefetch,
        x86_prefetchw,
        x86_addps,
        x86_addss,
        x86_andnps,
        x86_andps,
        x86_cmpps,
        x86_cmpss,
        x86_comiss,
        x86_cvtpi2ps,
        x86_cvtps2pi,
        x86_cvtsi2ss,
        x86_cvtss2si,
        x86_cvttps2pi,
        x86_cvttss2si,
        x86_divps,
        x86_divss,
        x86_ldmxcsr,
        x86_maxps,
        x86_maxss,
        x86_minps,
        x86_minss,
        x86_movaps,
        x86_movhlps,
        x86_movhps,
        x86_movlhps,
        x86_movlps,
        x86_movmskps,
        x86_movss,
        x86_movups,
        x86_mulps,
        x86_mulss,
        x86_orps,
        x86_rcpps,
        x86_rcpss,
        x86_rsqrtps,
        x86_rsqrtss,
        x86_shufps,
        x86_sqrtps,
        x86_sqrtss,
        x86_stmxcsr,
        x86_subps,
        x86_subss,
        x86_ucomiss,
        x86_unpckhps,
        x86_unpcklps,
        x86_xorps,
        x86_pavgb,
        x86_pavgw,
        x86_pextrw,
        x86_pinsrw,
        x86_pmaxsw,
        x86_pmaxub,
        x86_pminsw,
        x86_pminub,
        x86_pmovmskb,
        x86_pmulhuw,
        x86_psadbw,
        x86_pshufw,
        x86_maskmovq,
        x86_movntps,
        x86_movntq,
        x86_prefetcht0,
        x86_prefetcht1,
        x86_prefetcht2,
        x86_prefetchnta,
        x86_sfence,
        x86_cmpeqps,
        x86_cmpltps,
        x86_cmpleps,
        x86_cmpunordps,
        x86_cmpneqps,
        x86_cmpnltps,
        x86_cmpnleps,
        x86_cmpordps,
        x86_cmpeqss,
        x86_cmpltss,
        x86_cmpless,
        x86_cmpunordss,
        x86_cmpneqss,
        x86_cmpnltss,
        x86_cmpnless,
        x86_cmpordss,
        x86_pf2iw,
        x86_pfnacc,
        x86_pfpnacc,
        x86_pi2fw,
        x86_pswapd,
        x86_fstp1,
        x86_fcom2,
        x86_fcomp3,
        x86_fxch4,
        x86_fcomp5,
        x86_ffreep,
        x86_fxch7,
        x86_fstp8,
        x86_fstp9
};

#endif
