#ifndef  __OBJREC_H
#define  __OBJREC_H

#if defined(__OBJREC)
#define  PROGRAM_NAME   "OBJ_REC"
#define  MAJOR_VERSION  0
#define  MINOR_VERSION  2
#define  HELP_STRING    "This plugin helps in reconstructing Structures and Classes from pointers\n"
#define  WANTED_KEY     "Alt-1"
#endif

enum rec_t{
   rec_none,      // no recursion at all, but ptr parsing
   rec_cdecl,     // __cdecl & stdcall recursion
   rec_register,  // register tracing engine
   rec_full,      // both register and cdecl recursion
   rec_justflow   // just straight flow parsing without pointer crap
};

// Now comes the form data for the main configuration form

#if defined(__OBJREC)
static const char cfg_box[] =
   "STARTITEM 0\n"
   "HELP\n"
   "This dialog box controls the way the plugin operates\n\n"
   "Start address\t-\tThis is the location where the plugin should\n"
   "\t\t\tstart it's work.\n"
   "Structure name\t-\tThis is the name of the structure the plugin\n"
   "\t\t\twill create.\n"
   "Stackvar/Register\t-\tThis is the name of the stack variable or\n"
   "\t\t\tthe CPU register the plugin should parse\n"
   "No recursion\t-\tMeans that the plugin will trace until either\n"
   "\t\t\tthe pointer it is following is overwritten or \n"
   "\t\t\ta return is found\n"
   "push recursion\t-\tMeans that the plugin will trace the passing\n"
   "\t\t\tof the pointer down the call tree when it is \n"
   "\t\t\tpushed on the stack (__cdecl, __stdcall etc)\n"
   "register recursion\t-\tMeans that the plugin will trace the passing\n"
   "\t\t\tof the pointer down the call tree when it is \n"
   "\t\t\tpassed in one of the CPU registers (__thiscall, __fastcall)\n"
   "Full recursion\t-\tincorporates both push and register recursion\n"
   "Flow parsing\t-\twill only parse control flow similar to IDA's\n"
   "\t\t\tbuilt-in graphing functionality\n"
   "Vtable parsing\t-\twill enable the vtable parsing mode to re-\n"
   "\t\t\tcover classes\n"
   "ENDHELP\n"
   "OBJRec/STRec settings\n\n\n"
   "<~S~tart address     :$:10:20::>\n"
   "<S~t~ructure name    :A:20:20::>\n"
   "<Stac~k~ Variable or register to trace:A:10:20::>\n"
   "<~N~o recursion:R>\n"
   "<~p~ush recursion:R>\n"
   "<~r~egister recursion:R>\n"
   "<~F~ull recursion:R>\n"
   "<F~l~ow parsing only:R>>\n"
   "<~V~table parsing mode (OOP):C>>\n";
//
#endif

#if defined(__OBJREC)
char  StrucName[500];   // the name of the currently created structure,
                        // needed in legacy.cpp, therefore it is already
                        // declared here
#else
extern char  StrucName[];
#endif

int show_cfg_box(ea_t startEA, char *struname, char *reg, int rec_mask, int vtblmod);
void  ReconstructFromAddr(ea_t curr, char *regname, rec_t rec_mode, char *strucname);

#endif

