#ifndef  __PTRGRAPH
#define  __PTRGRAPH

// this is a modified graph.cpp to make ptrgrapher
// This is my second day of C++ coding -- forgive me if this is crap

#include <stdio.h>
#include <string.h>
#include "graphnode.hpp"
#include "insx86.hpp"
#include "ptrgraph.hpp"

#include <algorithm>

struct CompareMinBegin
{
    inline bool operator() (GraphNode* x, GraphNode* y) const
    {
        return x->GetBegin() < y->GetBegin();
    }
};

GraphNode *PtrGraph::FindNodeByIndex(const unsigned int index)
{
   if (index > numnodes)
   {
      return (0);
   }
   return (vec_allNodes[index]);
}


void PtrGraph::SortByBegin()
{
    std::sort(vec_allNodes.begin(), vec_allNodes.end(), CompareMinBegin());

    unsigned int  tmp, highest_beg, cnt;
    for (tmp = 0, highest_beg = 0, cnt=0; tmp < numnodes; tmp++)
    {
       if (vec_allNodes[tmp]->GetBegin() != highest_beg)
       {
          cnt++;
          highest_beg = vec_allNodes[tmp]->GetBegin();
       }
       vec_allNodes[tmp]->SetVertical(cnt);
    }
}

PtrGraph::PtrGraph()
{
   vec_allNodes.reserve(1000);
   vec_allNodes.clear();
   numnodes = 1;
   vec_allNodes.push_back(new(GraphNode));
   vec_allNodes[0]->SetNodeName("root");
}

PtrGraph::~PtrGraph()
{
   for (unsigned int i = 0; i < vec_allNodes.size(); i++)
   {
      delete (vec_allNodes[i]);      /* free memory and call destructor for GraphNode */
   }
}

GraphNode *PtrGraph::FindNodeByBegin(const unsigned int ea_begin)
{
   for(unsigned int i = 0; i < numnodes; i++)
   {
      if (vec_allNodes[i]->GetBegin() == ea_begin)
      {
         return (vec_allNodes[i]);
      }
   }
   return (0);
}

GraphNode *PtrGraph::FindNodeByName(const char *name)
{
   for(unsigned int i = 0; i < numnodes; i++)
   {
      if (strcmp(name, vec_allNodes[i]->GetNodeName()) == 0)
      {
         return (vec_allNodes[i]);
      }
   }
   return (NULL);
}

GraphNode *PtrGraph::AddNode(GraphNode *from, char *name)
{
   GraphNode *new_ptr = new(GraphNode);

   if ( new_ptr == NULL )
   {
        return NULL;
   }

   if ( vec_allNodes.size() + 5 > vec_allNodes.capacity() )
   {
        if ( vec_allNodes.size() + 1000 > vec_allNodes.max_size() )
        {
            delete new_ptr;
            return NULL;
        }
        vec_allNodes.reserve(vec_allNodes.size() + 1000);
   }
   vec_allNodes.push_back(new_ptr);
   numnodes++;

   if ( numnodes != vec_allNodes.size() )  /* just in case :)) */
   {
        delete new_ptr;
        numnodes--;
        return NULL;
   }
   vec_allNodes[numnodes-1]->SetNodeName(name);
   from->AddDownLink(vec_allNodes[numnodes-1]);
   return (vec_allNodes[numnodes-1]);
}

void PtrGraph::OutputWingraphFile(char *filename)
{
   FILE  *fpout;
   static const char  header[] = {
      "graph: {\n"
      "title: \"Graph Visualization\"\n"
      "manhattan_edges: yes\n"
      "layoutalgorithm: mindepth\n"
      "finetuning: no\n"
      "layout_downfactor: 100\n"
      "layout_upfactor: 0\n"
      "layout_nearfactor: 0\n"
      "xlspace: 12\n"
      "yspace: 30\n"};
   unsigned int   i, i2, numlinks;
   GraphNode      *linked_node;

   fpout = fopen(filename, "w+");
   if ( fpout == NULL )
   {
       msg("Can't open '%s'\n", filename);
       return ;                         /* fopen failed */
   }

   fprintf(fpout, header);
   for(i = 1; i < numnodes; i++) // skip rootnode
   {
      numlinks = vec_allNodes[i]->GetLinkNumDown();
      fprintf(fpout, "node: { ");
      fprintf(fpout, "title: \"%s\" ", vec_allNodes[i]->GetNodeName());
      fprintf(fpout, "label: \"\n");
      fprintf(fpout, "NodeBegin: %lx\n", vec_allNodes[i]->GetBegin());
      fprintf(fpout, "NodeEnd:   %lx\n", vec_allNodes[i]->GetEnd());
      if (vec_allNodes[i]->GetReg() == r_none)
      {
         fprintf(fpout, "StackOfs:  %lx\n", vec_allNodes[i]->GetVarOfs());
      }
      else
      {
         fprintf(fpout, "Register:  %s\n", vec_allNodes[i]->GetRegString(vec_allNodes[i]->GetReg()));
      }
      if (vec_allNodes[i]->GetNodeText() != 0)
      {
         fprintf(fpout, "%s\n", vec_allNodes[i]->GetNodeText());
      }

      fprintf(fpout, "\"\n");   // node description end
      if (vec_allNodes[i]->GetVertical() != BADNODE)
      {
         fprintf(fpout, "vertical_order: %d\n", vec_allNodes[i]->GetVertical());
      }

      fprintf(fpout, "}\n");

      for (i2 = 0; i2 < numlinks; i2++)
      {
         linked_node = vec_allNodes[i]->GetDownLink(i2+1);

         fprintf(fpout, "edge: { sourcename: \"%s\" targetname: \"%s\" }\n",
                vec_allNodes[i]->GetNodeName(), linked_node->GetNodeName());
      }
   }
   fprintf(fpout, "}\n");
   fclose(fpout);
}

#endif
